/*
 * file:winsock2bind_example1.c
 * The bind function associates a local address with a socket.
 * Q http://msdn.microsoft.com/library/default.asp?url=/library/en-us/winsock/winsock/bind_2.asp
 */
#include <stdio.h>
#include "winsock2.h"

int main()
{
    /*
     * ϐ̐錾B
     */
    WSADATA wsaData;
    int iResult = 0;
    SOCKET ListenSocket;
    struct sockaddr_in service;

    /*
     * Winsock̏B
     */
    iResult = WSAStartup(MAKEWORD(2, 2), &wsaData);
    if (iResult != NO_ERROR)
    {
        printf("Error at WSAStartup()\n");
        return 0;
    }

    /*
     * ڑvp̃XjOp̃\Pbg쐬B
     */
    ListenSocket = socket(AF_INET, SOCK_STREAM, IPPROTO_TCP);
    if (ListenSocket == INVALID_SOCKET)
    {
        printf("Error at socket(): %ld\n", WSAGetLastError());
        WSACleanup();
        return 0;
    }

    /*
     * sockaddr_in\̂͂̃AhXt@~Bw肷A
     * IPAhXAāAтĂ\Pbĝ߂̃|[gB
     */
    service.sin_family = AF_INET;
    service.sin_addr.s_addr = inet_addr("127.0.0.1");
    service.sin_port = htons(27015);

    /*
     * \PbgoChB
     */
    if (bind(ListenSocket, (SOCKADDR*)&service, sizeof(service))
            == SOCKET_ERROR)
    {
        printf("bind() failed.\n");
        closesocket(ListenSocket);
        return 0;
    }

    WSACleanup();
    return 0;
}
